﻿/**
 * Copyright 2008 - TMTDigital LLC
 *
 * Author:   Travis Tidwell (www.travistidwell.com)
 * Version:  1.0
 * Date:     June 9th, 2008
 *
 * Description:   A class for each playlist Link in the playlist section.
 *
 **/

package com.tmtdigital.dash.display
{
   import com.tmtdigital.dash.display.Link;
	import com.tmtdigital.dash.utils.LayoutManager;
	import com.tmtdigital.dash.config.Params;
	
   import flash.display.*;

   public class PlaylistLink extends Link
   {
      public function PlaylistLink( _skin:MovieClip )
      {
         super( _skin, Params.flashVars.disableplaylist );
      }

		public override function setLink( _text:String, _arg:String, _index:Number )
		{
			super.setLink( _text, _arg, _index );
			
			if( skin.backgroundMC && linkText ) {
				skin.backgroundMC.width = linkText.textWidth + LayoutManager.linkpadding; 
			}
		}

      public override function setSelected( _selected:Boolean )
      {
         super.setSelected( _selected );
         skin.y = _selected ? 1 : 0;
      }
		
      public override function up()
      {
         if ( skin.backgroundMC ) {
            skin.backgroundMC.gotoAndStop( "_up" );
         }
      }

      public override function over()
      {
         if ( skin.backgroundMC ) {
            skin.backgroundMC.gotoAndStop( "_over" );
         }
      }

      public override function down()
      {
         if ( skin.backgroundMC ) {
            skin.backgroundMC.gotoAndStop( "_down" );
         }
      }		
   }
}